V2EX = way to explore
V2EX 是一个关于分享和探索的地方
现在注册
已注册用户请  登录
julyclyde
V2EX  ›  Vim

git 用 vi,而我的 vimrc 是 vim 的

  •  
  •   julyclyde · 73 天前 · 1677 次点击
    这是一个创建于 73 天前的主题,其中的信息可能已经有所发展或是发生改变。

    前几天听同事介绍,找了几个 Vundle 、ctrlp 之类的插件,配置了~/.vimrc 写了几句 Plugin 之类的指令

    然后就发现,凡是我自己用 vim 就正常,但是 git commit 的时候总是提示不识别 Plugin 命令 进一步检查,发现 git 调用的是 vi 命令,是由 vim-minimal 软件包提供的;我用的 vim 命令,是由 vim-enhanced 软件包提供的。没有 alternative 机制管理 vi 命令

    然后我就搜啊,https://git-scm.com/book/en/v2/Customizing-Git-Git-Configuration 文档说 core.editor By default, Git uses whatever you’ve set as your default text editor via one of the shell environment variables VISUAL or EDITOR, or else falls back to the vi editor to create and edit your commit and tag messages.

    所以我最后只好用符号链接解决了这个问题,让 git 通过符号链接 vi 来调用 vim

    但是多了一个不属于包管理的可执行文件,感觉很 dirty 请问有没有干净一些的做法?

    我这里 CentOS 7 旧操作系统

    12 条回复    2022-11-23 23:04:55 +08:00
    boris93
        1
    boris93  
       73 天前 via iPhone
    文档里都说了啊,配置环境变量 VISUAL 或者 EDITOR ,指定 vim 就行了
    julyclyde
        2
    julyclyde  
    OP
       73 天前
    @boris93 感觉也不干净啊。这环境变量的影响范围是超过 git 的
    Maboroshii
        3
    Maboroshii  
       73 天前 via Android
    .gitconfig 可以指定 editor
    yanghanlin
        4
    yanghanlin  
       73 天前
    git config --global core.editor vim
    ampedee
        5
    ampedee  
       73 天前 via iPhone   ❤️ 1
    下次耐心点,你引用的那段文档的下一句就告诉了你 core.editor 配置可以单独为 git 配置编辑器
    GiantHard
        6
    GiantHard  
       73 天前 via Android
    @julyclyde 其实也还好,很多软件都认 EDITOR VISUAL 这俩环境变量,这样你之后就不用为其他的程序修改配置了
    julyclyde
        7
    julyclyde  
    OP
       73 天前
    @yanghanlin
    @ampedee
    @Maboroshii
    我这种情况,大家建议在 system 还是 global 还是 local 级别配置 core.editor 呢?
    感觉 system 比较好?
    dingwen07
        8
    dingwen07  
       73 天前 via iPhone
    @julyclyde #7 git 的 global 是你的用户
    不加 global 就是 repo specific
    julyclyde
        9
    julyclyde  
    OP
       73 天前
    @dingwen07 这样的话,在“我自己用一台机器”的前提下,system 和 globla 其实相当于相同的 scope 了吧
    那我选 global 吧。谢谢大家
    adoal
        10
    adoal  
       73 天前
    VISUAL 、EDITOR 是“其它”软件需要起一个编辑器来交互操作时需要的,那你担心啥污染呢,反正都是你自己在 shell 下操作时才会跳出来,难不成你想 git commit 时跳 vim-enhanced ,vipw 或 visudo 时就用纯洁的默认编辑器?

    另外,如果你只是介意 git commit 时 vim-minimal 报错,并不介意真的用 vim-minimal 写 commit message ,那是不是应该考虑在 vimrc 里判断一下 compatible mode 啊。
    julyclyde
        11
    julyclyde  
    OP
       73 天前
    @adoal 我用 vim 不“深入”,写不来判断语句
    BrettD
        12
    BrettD  
       73 天前
    EDITOR 环境变量本来就是干这个用的
    关于   ·   帮助文档   ·   博客   ·   API   ·   FAQ   ·   我们的愿景   ·   广告投放   ·   实用小工具   ·   1011 人在线   最高记录 5497   ·     Select Language
    创意工作者们的社区
    World is powered by solitude
    VERSION: 3.9.8.5 · 34ms · UTC 00:31 · PVG 08:31 · LAX 16:31 · JFK 19:31
    Developed with CodeLauncher
    ♥ Do have faith in what you're doing.